Bug 40514 - would like GracefulShutdownTimeout to work for graceful restarts too
Summary: would like GracefulShutdownTimeout to work for graceful restarts too
Status: RESOLVED LATER
Alias: None
Product: Apache httpd-2
Classification: Unclassified
Component: All (show other bugs)
Version: 2.2.2
Hardware: Other Linux
: P2 normal (vote)
Target Milestone: ---
Assignee: Apache HTTPD Bugs Mailing List
URL:
Keywords: MassUpdate
Depends on:
Blocks:
 
Reported: 2006-09-14 20:48 UTC by Jeff Long
Modified: 2019-09-11 03:21 UTC (History)
0 users



Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Jeff Long 2006-09-14 20:48:29 UTC
Running 2.2.3 here on RHEL 3.  We use cgiwrap (a suexec clone, see
cgiwrap.sf.net) (due to historical reasons) to run user cgi programs (via
mod_cgi in prefork mode).  Nightly we have a cron job that uses 'apachectl
graceful' to restart things so logs can be rotated.  I've noticed that if a
user's script hangs for some reason (i.e. no CPU time is being used) that after
5 minutes or so apache will complain about the CGI request timing out and then
the httpd child that spawned the CGI will enter the C state.  When the
'apachectl graceful' is issued then that httpd child will enter the G state and
stay around in that state perpetually.  What I would like is for something like
GracefulShutdownTimeout to apply to graceful restarts and not just graceful
stops so that after a configured amount of time apache would start forcefully
killing these hung httpd children.

Here's an example cgi that can be used to see this problem:

#!/usr/local/bin/php

<?php

while (1) {
        $i = 1;
        sleep(500);
}
?>

Just run that, wait until apache reports the CGI timed out and it has entered
the C state.  Then do a graceful restart upon which it will enter the G state
and keep running.  I've verified this also happens when running the CGI via suexec.
Comment 1 William A. Rowe Jr. 2018-11-07 21:09:46 UTC
Please help us to refine our list of open and current defects; this is a mass update of old and inactive Bugzilla reports which reflect user error, already resolved defects, and still-existing defects in httpd.

As repeatedly announced, the Apache HTTP Server Project has discontinued all development and patch review of the 2.2.x series of releases. The final release 2.2.34 was published in July 2017, and no further evaluation of bug reports or security risks will be considered or published for 2.2.x releases. All reports older than 2.4.x have been updated to status RESOLVED/LATER; no further action is expected unless the report still applies to a current version of httpd.

If your report represented a question or confusion about how to use an httpd feature, an unexpected server behavior, problems building or installing httpd, or working with an external component (a third party module, browser etc.) we ask you to start by bringing your question to the User Support and Discussion mailing list, see [https://httpd.apache.org/lists.html#http-users] for details. Include a link to this Bugzilla report for completeness with your question.

If your report was clearly a defect in httpd or a feature request, we ask that you retest using a modern httpd release (2.4.33 or later) released in the past year. If it can be reproduced, please reopen this bug and change the Version field above to the httpd version you have reconfirmed with.

Your help in identifying defects or enhancements still applicable to the current httpd server software release is greatly appreciated.